<?php
defined( 'ABSPATH' ) || die();

class STCFQ_Database {
	/**
	 * Plugin activation.
	 *
	 * @return void
	 */
	public static function activation() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		require_once ABSPATH . 'wp-admin/includes/upgrade.php';

		/* Create stcfq_queries table */
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}stcfq_queries (
				ID bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
				name varchar(255) DEFAULT NULL,
				email varchar(255) DEFAULT NULL,
				subject varchar(255) DEFAULT NULL,
				message text DEFAULT NULL,
				answered tinyint(1) NOT NULL DEFAULT '0',
				note text DEFAULT NULL,
				created_at timestamp NULL DEFAULT CURRENT_TIMESTAMP,
				updated_at timestamp NULL DEFAULT NULL,
				PRIMARY KEY (ID)
				) $charset_collate";
		dbDelta( $sql );
	}
}
