(function($) {
	'use strict';
	$(document).ready(function() {

		$(document).on('click', '.stcfq-filter-add-item', function() {
			$('.stcfq-filter-item').first().clone().find('input').attr({ value: '' }).end().appendTo('.stcfq-filter-items');
		});

		$(document).on('click', '.stcfq-filter-remove-item', function() {
			var searchItemsLength = $('.stcfq-filter-items .stcfq-filter-item').length;
			if(searchItemsLength > 1) {
				$(this).parent().remove();
			}
		});

		var googleRecaptchaV2 = $('.stcfq_google_recaptcha_v2');
		var captcha = $('.stcfq input[name="captcha"]:checked').val();
		if('google_recaptcha_v2' === captcha) {
			googleRecaptchaV2.show();
		}

		$(document).on('change', '.stcfq input[name="captcha"]', function() {
			var captcha = this.value;
			var stcfqCaptcha = $('.stcfq_captcha');
			stcfqCaptcha.hide();
			if('google_recaptcha_v2' === captcha) {
				googleRecaptchaV2.fadeIn();
			}
		});

		var wpMail = $('.stcfq_wp_mail');
		var smtp = $('.stcfq_smtp');
		var emailCarrier = $('.stcfq input[name="email_carrier"]:checked').val();
		if('wp_mail' === emailCarrier) {
			wpMail.show();
		} else if('smtp' === emailCarrier) {
			smtp.show();
		}

		$(document).on('change', '.stcfq input[name="email_carrier"]', function() {
			var emailCarrier = this.value;
			var stcfqEmail = $('.stcfq_email');
			stcfqEmail.hide();
			if('wp_mail' === emailCarrier) {
				wpMail.fadeIn();
			} else if('smtp' === emailCarrier) {
				smtp.fadeIn();
			}
		});

		$('.stcfq-accordion').each(function() {
			$(this).on('click', function(event) {
				event.preventDefault();
				this.classList.toggle('stcfq-accordion-active');
				var panel = this.nextElementSibling;
				if (panel.style.maxHeight){
					panel.style.maxHeight = null;
				} else {
					panel.style.maxHeight = panel.scrollHeight + "px";
				} 
			});
		});

		try {
			$('#stcfq-form-field-settings').sortable({
				placeholder: '',
				revert: true
			});
		} catch(e) {}

		$(document).on('click', '.st-alert-box-dismiss', function() {
			$(this).parent().fadeOut(200, function() {
				$(this).remove();
			});
		});

		$(document).on('click', '.stcfq-delete-message', function(event) {
			event.preventDefault();
			var button = this;
			var header = '.stcfq-table';
			var messageId = $(this).data('message');
			var nonce = $(this).data('nonce');
			var confirmMessage = $(this).data('message-confirm');

			if(confirm(confirmMessage)) {
				$.ajax({
					data: 'id=' + messageId + '&' + 'delete-message-' + messageId + '=' + nonce + '&action=stcfq-delete-message',
					url: ajaxurl,
					type: 'POST',
					beforeSend: function(xhr) {
						$('.st-alert-box').remove();
					},
					success: function(response) {
						if(response.success) {
							var alertBox = '' +
							'<div class="st-alert-box notice notice-success is-dismissible">' +
								'<p>' +
									'<strong>' + response.data.message + '</strong>' +
								'</p>' +
								'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
							'</div>';
							$(alertBox).insertBefore(header);
							$(button).parent().parent().remove();
						} else {
							var errorSpan = '' +
							'<div class="st-alert-box notice notice-error is-dismissible" tabindex="-1">' +
								'<p>' +
									'<strong>' + response.data + '</strong>' +
								'</p>' +
								'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
							'</div>';
							$(errorSpan).insertBefore(header).focus();
						}
					},
					error: function(response) {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible" tabindex="-1">' +
							'<p>' +
								'<strong>' + response.status + '</strong>&nbsp;' + response.statusText +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(header).focus();
					}
				});
			}
		});

		var loadingContainer = $('<span/>', {
			'class': 'st-loading-container'
		});
		var loadingImage = $('<img/>', {
			'src': stcfqadminurl + 'images/spinner.gif',
			'class': 'st-loading-image'
		});

		// Save note.
		var saveNoteFormId = '#stcfq-save-note-form';
		var saveNoteForm = $(saveNoteFormId);
		var saveNoteBtn = $('#stcfq-save-note-btn');
		saveNoteForm.ajaxForm({
			beforeSubmit: function(arr, $form, options) {
				$('.st-text-danger').remove();
				$('.st-is-invalid').removeClass("st-is-invalid");
				$('.st-alert-box').remove();
				saveNoteBtn.prop('disabled', true);
				loadingContainer.insertAfter(saveNoteBtn);
				loadingImage.appendTo(loadingContainer);
				return true;
			},
			success: function(response) {
				if(response.success) {
					var alertBox = '' +
					'<div class="st-alert-box notice notice-success is-dismissible">' +
						'<p>' +
							'<strong>' + response.data.message + '</strong>' +
						'</p>' +
						'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
					'</div>';
					$(alertBox).insertBefore(saveNoteFormId);
				} else {
					if(response.data && $.isPlainObject(response.data)) {
						$(saveNoteFormId + ' :input').each(function() {
							var input = this;
							$(input).removeClass('st-is-invalid');
							if(response.data[input.name]) {
								var errorSpan = '<div class="st-text-danger">' + response.data[input.name] + '</div>';
								$(input).addClass('st-is-invalid');
								$(errorSpan).insertAfter(input);
							}
						});
					} else {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible">' +
							'<p>' +
								'<strong>' + response.data + '</strong>' +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(saveNoteFormId);
					}
				}
			},
			error: function(response) {
				saveNoteBtn.prop('disabled', false);
				var errorSpan = '' +
				'<div class="st-alert-box notice notice-error is-dismissible">' +
					'<p>' +
						'<strong>' + response.status + '</strong> ' + response.statusText +
					'</p>' +
					'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
				'</div>';
				$(errorSpan).insertBefore(saveNoteFormId);
			},
			complete: function(event, xhr, settings) {
				saveNoteBtn.prop('disabled', false);
				loadingContainer.remove();
			}
		});

		// Save form fields.
		var saveFormFieldsFormId = '#stcfq-save-form-fields-form';
		var saveFormFieldsForm = $(saveFormFieldsFormId);
		var saveFormFieldsBtn = $('#stcfq-save-form-fields-btn');
		saveFormFieldsForm.ajaxForm({
			beforeSubmit: function(arr, $form, options) {
				$('.st-text-danger').remove();
				$('.st-is-invalid').removeClass("st-is-invalid");
				$('.st-alert-box').remove();
				saveFormFieldsBtn.prop('disabled', true);
				loadingContainer.insertAfter(saveFormFieldsBtn);
				loadingImage.appendTo(loadingContainer);
				return true;
			},
			success: function(response) {
				if(response.success) {
					var alertBox = '' +
					'<div class="st-alert-box notice notice-success is-dismissible">' +
						'<p>' +
							'<strong>' + response.data.message + '</strong>' +
						'</p>' +
						'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
					'</div>';
					$(alertBox).insertBefore(saveFormFieldsFormId);
				} else {
					if(response.data && $.isPlainObject(response.data)) {
						$(saveFormFieldsFormId + ' :input').each(function() {
							var input = this;
							$(input).removeClass('st-is-invalid');
							if(response.data[input.name]) {
								var errorSpan = '<div class="st-text-danger">' + response.data[input.name] + '</div>';
								$(input).addClass('st-is-invalid');
								$(errorSpan).insertAfter(input);
							}
						});
					} else {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible">' +
							'<p>' +
								'<strong>' + response.data + '</strong>' +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(saveFormFieldsFormId);
					}
				}
			},
			error: function(response) {
				saveFormFieldsBtn.prop('disabled', false);
				var errorSpan = '' +
				'<div class="st-alert-box notice notice-error is-dismissible">' +
					'<p>' +
						'<strong>' + response.status + '</strong> ' + response.statusText +
					'</p>' +
					'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
				'</div>';
				$(errorSpan).insertBefore(saveFormFieldsFormId);
			},
			complete: function(event, xhr, settings) {
				saveFormFieldsBtn.prop('disabled', false);
				loadingContainer.remove();
			}
		});

		// Save captcha.
		var saveCaptchaFormId = '#stcfq-save-captcha-form';
		var saveCaptchaForm = $(saveCaptchaFormId);
		var saveCaptchaBtn = $('#stcfq-save-captcha-btn');
		saveCaptchaForm.ajaxForm({
			beforeSubmit: function(arr, $form, options) {
				$('.st-text-danger').remove();
				$('.st-is-invalid').removeClass("st-is-invalid");
				$('.st-alert-box').remove();
				saveCaptchaBtn.prop('disabled', true);
				loadingContainer.insertAfter(saveCaptchaBtn);
				loadingImage.appendTo(loadingContainer);
				return true;
			},
			success: function(response) {
				if(response.success) {
					var alertBox = '' +
					'<div class="st-alert-box notice notice-success is-dismissible">' +
						'<p>' +
							'<strong>' + response.data.message + '</strong>' +
						'</p>' +
						'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
					'</div>';
					$(alertBox).insertBefore(saveCaptchaFormId);
				} else {
					if(response.data && $.isPlainObject(response.data)) {
						$(saveCaptchaFormId + ' :input').each(function() {
							var input = this;
							$(input).removeClass('st-is-invalid');
							if(response.data[input.name]) {
								var errorSpan = '<div class="st-text-danger">' + response.data[input.name] + '</div>';
								$(input).addClass('st-is-invalid');
								$(errorSpan).insertAfter(input);
							}
						});
					} else {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible">' +
							'<p>' +
								'<strong>' + response.data + '</strong>' +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(saveCaptchaFormId);
					}
				}
			},
			error: function(response) {
				saveCaptchaBtn.prop('disabled', false);
				var errorSpan = '' +
				'<div class="st-alert-box notice notice-error is-dismissible">' +
					'<p>' +
						'<strong>' + response.status + '</strong> ' + response.statusText +
					'</p>' +
					'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
				'</div>';
				$(errorSpan).insertBefore(saveCaptchaFormId);
			},
			complete: function(event, xhr, settings) {
				saveCaptchaBtn.prop('disabled', false);
				loadingContainer.remove();
			}
		});

		// Save email.
		var saveEmailFormId = '#stcfq-save-email-form';
		var saveEmailForm = $(saveEmailFormId);
		var saveEmailBtn = $('#stcfq-save-email-btn');
		saveEmailForm.ajaxForm({
			beforeSubmit: function(arr, $form, options) {
				$('.st-text-danger').remove();
				$('.st-is-invalid').removeClass("st-is-invalid");
				$('.st-alert-box').remove();
				saveEmailBtn.prop('disabled', true);
				loadingContainer.insertAfter(saveEmailBtn);
				loadingImage.appendTo(loadingContainer);
				return true;
			},
			success: function(response) {
				if(response.success) {
					var alertBox = '' +
					'<div class="st-alert-box notice notice-success is-dismissible">' +
						'<p>' +
							'<strong>' + response.data.message + '</strong>' +
						'</p>' +
						'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
					'</div>';
					$(alertBox).insertBefore(saveEmailFormId);
				} else {
					if(response.data && $.isPlainObject(response.data)) {
						$(saveEmailFormId + ' :input').each(function() {
							var input = this;
							$(input).removeClass('st-is-invalid');
							if(response.data[input.name]) {
								var errorSpan = '<div class="st-text-danger">' + response.data[input.name] + '</div>';
								$(input).addClass('st-is-invalid');
								$(errorSpan).insertAfter(input);
							}
						});
					} else {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible">' +
							'<p>' +
								'<strong>' + response.data + '</strong>' +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(saveEmailFormId);
					}
				}
			},
			error: function(response) {
				saveEmailBtn.prop('disabled', false);
				var errorSpan = '' +
				'<div class="st-alert-box notice notice-error is-dismissible">' +
					'<p>' +
						'<strong>' + response.status + '</strong> ' + response.statusText +
					'</p>' +
					'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
				'</div>';
				$(errorSpan).insertBefore(saveEmailFormId);
			},
			complete: function(event, xhr, settings) {
				saveEmailBtn.prop('disabled', false);
				loadingContainer.remove();
			}
		});

		// Save uninstall setting.
		var saveUninstallSettingFormId = '#stcfq-save-uninstall-setting-form';
		var saveUninstallSettingForm = $(saveUninstallSettingFormId);
		var saveUninstallSettingBtn = $('#stcfq-save-uninstall-setting-btn');
		saveUninstallSettingForm.ajaxForm({
			beforeSubmit: function(arr, $form, options) {
				$('.st-text-danger').remove();
				$('.st-is-invalid').removeClass("st-is-invalid");
				$('.st-alert-box').remove();
				saveUninstallSettingBtn.prop('disabled', true);
				loadingContainer.insertAfter(saveUninstallSettingBtn);
				loadingImage.appendTo(loadingContainer);
				return true;
			},
			success: function(response) {
				if(response.success) {
					var alertBox = '' +
					'<div class="st-alert-box notice notice-success is-dismissible">' +
						'<p>' +
							'<strong>' + response.data.message + '</strong>' +
						'</p>' +
						'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
					'</div>';
					$(alertBox).insertBefore(saveUninstallSettingFormId);
				} else {
					if(response.data && $.isPlainObject(response.data)) {
						$(saveUninstallSettingFormId + ' :input').each(function() {
							var input = this;
							$(input).removeClass('st-is-invalid');
							if(response.data[input.name]) {
								var errorSpan = '<div class="st-text-danger">' + response.data[input.name] + '</div>';
								$(input).addClass('st-is-invalid');
								$(errorSpan).insertAfter(input);
							}
						});
					} else {
						var errorSpan = '' +
						'<div class="st-alert-box notice notice-error is-dismissible">' +
							'<p>' +
								'<strong>' + response.data + '</strong>' +
							'</p>' +
							'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
						'</div>';
						$(errorSpan).insertBefore(saveUninstallSettingFormId);
					}
				}
			},
			error: function(response) {
				saveUninstallSettingBtn.prop('disabled', false);
				var errorSpan = '' +
				'<div class="st-alert-box notice notice-error is-dismissible">' +
					'<p>' +
						'<strong>' + response.status + '</strong> ' + response.statusText +
					'</p>' +
					'<button type="button" class="st-alert-box-dismiss notice-dismiss"></button>' +
				'</div>';
				$(errorSpan).insertBefore(saveUninstallSettingFormId);
			},
			complete: function(event, xhr, settings) {
				saveUninstallSettingBtn.prop('disabled', false);
				loadingContainer.remove();
			}
		});

	});
})(jQuery);
