<?php
/**
 * Plugin Name: Contact Form Query
 * Description: Add a contact form and receive new message notification to your email and WordPress admin panel with filter option. View latest messages in dashboard.
 * Version: 1.0.6
 * Author: ScriptsTown
 * Author URI: https://scriptstown.com/
 * Text Domain: contact-form-query
*/

defined( 'ABSPATH' ) || die();

if ( ! defined( 'STCFQ_PLUGIN_URL' ) ) {
	define( 'STCFQ_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
}

if ( ! defined( 'STCFQ_PLUGIN_DIR_PATH' ) ) {
	define( 'STCFQ_PLUGIN_DIR_PATH', plugin_dir_path( __FILE__ ) );
}

if ( ! defined( 'STCFQ_PLUGIN_BASENAME' ) ) {
	define( 'STCFQ_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );
}

final class STCFQ_Contact_Form_Query {
	private static $instance = null;

	private function __construct() {
		$this->initialize_hooks();
		$this->setup_database();
	}

	public static function get_instance() {
		if ( is_null( self::$instance ) ) {
			self::$instance = new self();
		}
		return self::$instance;
	}

	private function initialize_hooks() {
		if ( is_admin() ) {
			require_once STCFQ_PLUGIN_DIR_PATH . 'admin/admin.php';
		}
		require_once STCFQ_PLUGIN_DIR_PATH . 'public/public.php';
	}

	private function setup_database() {
		require_once STCFQ_PLUGIN_DIR_PATH . 'admin/inc/class-stcfq-database.php';
		register_activation_hook( __FILE__, array( 'STCFQ_Database', 'activation' ) );
	}
}
STCFQ_Contact_Form_Query::get_instance();
