<?php
defined( 'ABSPATH' ) || die();

class STCFQ_Admin_Bar {
	public static function admin_bar_menu() {
		if ( current_user_can( 'manage_options' ) ) {
			require STCFQ_PLUGIN_DIR_PATH . 'includes/variables.php';
			global $wp_admin_bar;
			$wp_admin_bar->add_menu( array(
			'id'    => 'stcfq-messages-count',
			/* translators: %d: Number of unanswered messages */
			'title' => '<span class="ab-icon"></span><span class="ab-label awaiting-mod pending-count count-' . esc_attr( $messages_count ) . '" aria-hidden="true">' . esc_html( $messages_count ) . '</span><span class="screen-reader-text comments-in-moderation-text">' . sprintf( esc_html( _n( '%d Message not answered.', '%d Messages not answered', $messages_count, 'contact-form-query' ) ), $messages_count ) . '</span>',
			'href'  => esc_url( admin_url( 'admin.php?page=stcfq_messages' ) ),
			) );
		}
	}

	public static function admin_bar_menu_assets() {
		if ( current_user_can( 'manage_options' ) ) {
			wp_enqueue_style( 'stcfq-admin-bar', STCFQ_PLUGIN_URL . 'assets/css/stcfq-admin-bar.css', array(), '1.0.6', 'all' );
		}
	}
}
